
-- ----------------------------------------------------------
--   Useful information goes here at the top.
-- ----------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity timer is
  port 
   (
       clk            : in  std_logic;
       timer_load     : in  std_logic_vector(15 downto 0); --ms units
       timer_start    : in  std_logic;
       ms_tick        : in  std_logic;
       timer_blink    : out std_logic;
       timer_done     : out std_logic
   );
end entity timer;

architecture Behavioral of timer is

   signal timer_count    : unsigned(15 downto 0) := X"0000";
   
begin

   timer_process : process(clk) 
   begin
      if rising_edge(clk) then
         if (timer_start = '1') then
            timer_count <= unsigned(timer_load);
         elsif (ms_tick = '1') then
            if (timer_count /= "0000") then
               timer_count <= timer_count - 1;
            end if;
         end if;
         --
         if (     ms_tick = '1'
              and timer_count = "0001"
            ) then
            timer_done <= '1';
         else
            timer_done <= '0';
         end if;
      end if;
   end process;

   timer_blink <= timer_count(8); --blinks every 1/4 second
   
end architecture Behavioral;



