
-- ----------------------------------------------------------
--   Useful information goes here at the top.
-- ----------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity baud is
  port (
        clk           : in   std_logic;
        baud_config   : in   std_logic_vector(15 downto 0);
        baud_en       : out  std_logic := '0'
        );
end entity baud;

architecture Behavioral of baud is

   signal baud_cnt          : unsigned(15 downto 0) := X"0004";
   
begin

   baud_proc : process(clk)
   begin
      if rising_edge(clk) then
         if (baud_cnt = X"0001") then
            baud_cnt <= unsigned(baud_config);
            baud_en  <= '1';
         else
            baud_cnt <= baud_cnt - 1;
            baud_en  <= '0';
         end if;
      end if;
   end process;
   
end architecture Behavioral;


