
-- ------------------------------------------------------
--   (Useful information.)
-- ------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.NUMERIC_STD.all;
use IEEE.STD_LOGIC_MISC.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity memory is
  port (
         clk           : in   std_logic;
         memory_adr    : in   std_logic_vector(10 downto 0);
         memory_wr     : in   std_logic;
         memory_wr_dat : in   std_logic_vector(7 downto 0);
         memory_rd_dat : out  std_logic_vector(7 downto 0)
       );
end entity memory;

architecture Behavioral of memory is

   type memory_type is array(0 to 2047) of std_logic_vector(7 downto 0);
   signal memory_array   : memory_type;
   signal memory_adr_int : integer;
   
begin

   memory_adr_int <= to_integer(unsigned(memory_adr));
   
   memory_process : process(clk)
   begin
      if rising_edge(clk) then
         if (memory_wr = '1') then
            memory_array(memory_adr_int) <= memory_wr_dat;
         end if;
         --
         memory_rd_dat <= memory_array(memory_adr_int);
      end if;
   end process;
   
end architecture Behavioral;


